(*
 * SNU 4541.664A Program Analysis 2017 Spring
 * K- Interpreter Solution
 * DongKwon Lee (dklee@ropas.snu.ac.kr)
 *)


(*
 * K- Interpreter
 *)

module type KMINUS =
sig
  exception Error of string
  type id = string
  type exp =
    | NUM of int
    | VAR of id
    | ADD of exp * exp
    | MINUS of exp
    
  type cmd =
  	| SKIP
	| SEQ of cmd * cmd            (* sequence *)
    | IF of exp * cmd * cmd       (* if-then-else *)
    | ASSIGN of id * exp          (* assgin to variable *)
    | READ of id				  (* input int to id *)
    | WRITE of exp				  (* output *)
    
  type program = cmd
  type memory
  type value
  val emptyMemory : memory
  val run : memory * program -> memory
end

module K : KMINUS =
struct
  exception Error of string
  type id = string
  type exp =
    | NUM of int   
	| VAR of id
    | ADD of exp * exp
    | MINUS of exp

  type cmd =
  	| SKIP
    | SEQ of cmd * cmd            (* sequence *)
    | IF of exp * cmd * cmd       (* if-then-else *)
    | ASSIGN of id * exp          (* assgin to variable *)
    | READ of id				  (* input int to id *)
    | WRITE of exp				  (* output *)

  type program = cmd

  type value = int
    
  type memory = id -> value		  (* you can use other memory type whatever you want *)
  
  let emptyMemory = fun id -> raise (Error "undefined variable")

  let rec eval : (memory * exp) -> value = fun (mem, e) ->
    match e with
    | NUM i -> i
	| VAR id -> (* TODO *) raise (Error "not impled")
	| ADD (e1, e2) -> (* TODO *) raise (Error "not impled")
	| MINUS e -> (* TODO *) raise (Error "not impled") 
	
  let rec run : (memory * program) -> memory = fun (mem, pgm) ->
    match pgm with
	| SKIP -> mem
    | SEQ (cmd1, cmd2) -> (* TODO *) raise (Error "not impled") 
    | IF (exp, cmd1, cmd2) -> (* TODO *) raise (Error "not impled") 
	| ASSIGN (id, exp) -> (* TODO *) raise (Error "not impled")
    | READ id -> (* TODO *) raise (Error "not impled")
    | WRITE exp -> (* TODO *) raise (Error "not impled")
end
