/*
 * SNU 4190.310 Programming Languages 
 *
 * K- Interpreter
 */
  

%{       

exception EmptyBinding
exception ParsingError

%}

%token UNIT SKIP
%token <int> NUM
%token <string> ID
%token PLUS MINUS COLONEQ SEMICOLON IF THEN ELSE
%token READ WRITE
%token LP RP
%token EOF

%nonassoc SKIP
%left SEMICOLON
%nonassoc THEN
%nonassoc ELSE
%right COLONEQ
%right WRITE 
%left PLUS MINUS


%start program
%type <K.K.cmd> program

%%

program:
       cmd EOF { $1 }
    ;

cmd: 
      LP cmd RP { $2 }
	| SKIP {K.K.SKIP}
	| IF expr cmd cmd { K.K.IF( $2, $3, $4) }
    | ID COLONEQ expr { K.K.ASSIGN ($1,$3) }
    | cmd SEMICOLON cmd { K.K.SEQ ($1,$3) }
    | IF expr THEN cmd ELSE cmd { K.K.IF ($2, $4, $6) }
    | READ ID { K.K.READ ($2) }
    | WRITE expr { K.K.WRITE ($2) }
    ;

expr:
	| LP expr RP { $2 }
	| NUM { K.K.NUM ($1) }
	| ID { K.K.VAR ($1) }
	| expr PLUS expr   { K.K.ADD ($1, $3) }
	| MINUS expr {K.K.MINUS ($2)}

%%
